import 'package:flutter/material.dart';
import 'package:unify_api/unify.dart';

class AddContactExample extends StatefulWidget {
  AddContactExample({
    @required this.client,
    this.contact,
  });
  final UnifyClient client;
  final ContactDetails contact;
  @override
  _AddContactExampleState createState() => _AddContactExampleState();
}

class _AddContactExampleState extends State<AddContactExample> {
  final TextEditingController _firstName = TextEditingController();
  final TextEditingController _middleName = TextEditingController();
  final TextEditingController _lastName = TextEditingController();
  final TextEditingController _suffix = TextEditingController();
  final TextEditingController _loanNumber = TextEditingController();
  final TextEditingController _secFirstName = TextEditingController();
  final TextEditingController _secMiddleName = TextEditingController();
  final TextEditingController _secLastName = TextEditingController();
  final TextEditingController _email = TextEditingController();
  final TextEditingController _secEmail = TextEditingController();

  List<CompanyCategory> _responses = [];
  CompanyCategory _value;

  @override
  void initState() {
    widget.client.listCompanyCategories().then((value) {
      setState(() {
        _responses = value;
        _value = widget?.contact?.companyCategory ?? _responses.first;
      });
    });
    setState(() {
      _value = widget?.contact?.companyCategory;
    });
    _firstName.text = widget?.contact?.firstName ?? "";
    _middleName.text = widget?.contact?.middleName ?? "";
    _lastName.text = widget?.contact?.lastName ?? "";
    _secFirstName.text = widget?.contact?.secondaryFirstName ?? "";
    _secMiddleName.text = widget?.contact?.secondaryMiddleName ?? "";
    _secLastName.text = widget?.contact?.secondaryLastName ?? "";
    _email.text = widget?.contact?.email ?? "";
    _secEmail.text = widget?.contact?.secondaryEmail ?? "";
    _suffix.text = widget?.contact?.suffix ?? "";
    _loanNumber.text = widget?.contact?.loanNumber ?? "";
    super.initState();
  }

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      appBar: AppBar(
        title: Text(widget?.contact == null ? "Add Contact" : "Edit Contact"),
      ),
      body: SingleChildScrollView(
        child: Column(
          mainAxisSize: MainAxisSize.min,
          children: <Widget>[
            ListTile(
              title: TextField(
                controller: _firstName,
                decoration: InputDecoration(hintText: "First Name"),
              ),
            ),
            ListTile(
              title: TextField(
                controller: _middleName,
                decoration: InputDecoration(hintText: "Middle Name"),
              ),
            ),
            ListTile(
              title: TextField(
                controller: _lastName,
                decoration: InputDecoration(hintText: "Last Name"),
              ),
            ),
            ListTile(
              title: TextField(
                controller: _suffix,
                decoration: InputDecoration(hintText: "Suffix"),
              ),
            ),
            ListTile(
              title: TextField(
                controller: _loanNumber,
                decoration: InputDecoration(hintText: "Loan Number"),
              ),
            ),
            ListTile(
              title: TextField(
                controller: _secFirstName,
                decoration: InputDecoration(hintText: "Secondary First Name"),
              ),
            ),
            ListTile(
              title: TextField(
                controller: _secMiddleName,
                decoration: InputDecoration(hintText: "Secondary Middle Name"),
              ),
            ),
            ListTile(
              title: TextField(
                controller: _lastName,
                decoration: InputDecoration(hintText: "Secondary Last Name"),
              ),
            ),
            ListTile(
              title: TextField(
                controller: _email,
                decoration: InputDecoration(hintText: "Email Address"),
              ),
            ),
            ListTile(
              title: TextField(
                controller: _secEmail,
                decoration:
                    InputDecoration(hintText: "Secondary Email Address"),
              ),
            ),
            // _value == null
            //     ? ListTile(
            //         title: Text("Loading..."),
            //         trailing: CircularProgressIndicator(),
            //       )
            //     : DropdownButtonFormField(
            //         items: _responses
            //             .map((r) => DropdownMenuItem<CompanyCategory>(
            //                   value: r,
            //                   child: Text(r?.name ?? ""),
            //                 ))
            //             .toList(),
            //         value: _value,
            //         onChanged: (CompanyCategory value) {
            //           setState(() {
            //             _value = value;
            //           });
            //         },
            //       ),
            RaisedButton.icon(
              icon: Icon(Icons.save),
              label: Text("Save"),
              onPressed: () => Navigator.pop(
                  context,
                  ContactDetails(
                      widget.client,
                      {
                        "First_Name": _firstName.text,
                        "Middle_Name": _middleName.text,
                        "Last_Name": _lastName.text,
                        "Suffix": _suffix.text,
                        "Loan_Number": _loanNumber.text,
                        // "Contact_Priority": contactPriority ?? 0,
                        "Secondary_First_Name": _secFirstName.text,
                        "Secondary_Middle_Name": _secMiddleName.text,
                        "Secondary_Last_Name": _secLastName.text,
                        // "Address": currentAddress,
                        // "Home_Phone": homePhone,
                        // "Office_Phone": officePhone,
                        // "Cell_Phone": cellPhone,
                        // "Secondary_Cell_Phone": secondaryCellPhone,
                        // "Fax_Phone": faxPhone,
                        "Email_Address": _email.text,
                        "Secondary_Email_Address": _secEmail.text,
                        // "Company_Category": companyCategory?.json,
                        // "Contact_Groups":
                        //     groups?.map((g) => g.json)?.toList() ?? [],
                      },
                      null)),
            )
          ],
        ),
      ),
    );
  }
}
