import 'package:flutter/material.dart';
import 'package:unify_api/unify.dart';

class AddLogResponseExample extends StatefulWidget {
  AddLogResponseExample({
    @required this.client,
    @required this.responses,
  });
  final UnifyClient client;
  final Future<List<String>> responses;
  @override
  _AddLogResponseExampleState createState() => _AddLogResponseExampleState();
}

class _AddLogResponseExampleState extends State<AddLogResponseExample> {
  final TextEditingController _controller = TextEditingController();
  List<String> _responses = [];
  String _value = "";

  @override
  void initState() {
    widget.responses.then((value) {
      setState(() {
        _responses = value;
        _value = _responses.first;
      });
    });
    super.initState();
  }

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      appBar: AppBar(
        title: Text("Add Log Response"),
      ),
      body: SingleChildScrollView(
        child: Column(
          mainAxisSize: MainAxisSize.min,
          children: <Widget>[
            ListTile(
              title: DropdownButtonFormField(
                items: _responses
                    .map((r) => DropdownMenuItem<String>(
                          value: r,
                          child: Text(r),
                        ))
                    .toList(),
                value: _value,
                onChanged: (String value) {
                  setState(() {
                    _value = value;
                  });
                },
              ),
            ),
            ListTile(
              title: TextField(
                controller: _controller,
                decoration: InputDecoration(hintText: "Comment"),
              ),
            ),
            RaisedButton.icon(
              icon: Icon(Icons.save),
              label: Text("Save"),
              onPressed: () => Navigator.pop(context, {
                    "action": _value,
                    "comment": _controller?.text ?? "",
                  }),
            )
          ],
        ),
      ),
    );
  }
}
