import 'dart:convert';

import 'package:flutter/material.dart';

class JsonButton extends StatelessWidget {
  const JsonButton({
    Key key,
    @required this.json,
  }) : super(key: key);

  final Map<String, dynamic> json;

  @override
  Widget build(BuildContext context) {
    return IconButton(
      icon: Icon(Icons.info_outline),
      onPressed: () {
        Navigator.push(
            context,
            MaterialPageRoute(
              builder: (BuildContext context) => JsonView(json),
              fullscreenDialog: true,
            ));
      },
    );
  }
}

class JsonView extends StatelessWidget {
  final Map<String, dynamic> json;
  JsonView(this.json);
  @override
  Widget build(BuildContext context) {
    JsonEncoder encoder = new JsonEncoder.withIndent('  ');
    String prettyprint = encoder.convert(json);
    return Scaffold(
      appBar: AppBar(title: Text("Json")),
      body: SafeArea(
          child: SingleChildScrollView(
        child: Column(
          children: <Widget>[
            Text(
              prettyprint,
              maxLines: null,
            ),
          ],
        ),
      )),
    );
  }
}
