part of unify;

class AccountInfo implements UnifyObject {
  AccountInfo(this.client, this.json);

  @override
  final UnifyClient client;

  @override
  final Map<String, dynamic> json;

  String get id => json['user_id'];

  String get firstName => json['first_name'];

  String get lastName => json['last_name'];

  String get fullName => json['full_name'] ?? '$firstName $lastName'.trim();

  String get displayName => '$lastName, $firstName';

  String get profileImage => json['profile_image_url'];

  String get title => json['title'];

  String get email => json['email'];

  String get facebookUrl => json['facebook_url'];

  String get twitterUrl => json['twitter_url'];

  String get linkedInUrl => json['linked_in'];

  String get websiteUrl => json['website_url'];

  String get companyId => json['company_id'];

  String get companyName => json['company_name'];

  String get companyImage => json['company_image_url'];

  String get kalturaId => json['kaltura_id'];

  String get licenseNumber => json['license_number'];

  String get losLicenseNumber => json['los_license_number'];

  bool get videoEnabled => json['video_enabled'] == null ? false : json['video_enabled'];

  PhoneNumber get primaryPhone => PhoneNumber(client, json['primary_phone']);

  PhoneNumber get secondaryPhone =>
      PhoneNumber(client, json['secondary_phone']);

  List<PhoneNumber> get numbers {
    final _items = <PhoneNumber>[];
    if (primaryPhone != null && primaryPhone.raw().isNotEmpty)
      _items.add(primaryPhone);
    if (secondaryPhone != null && secondaryPhone.raw().isNotEmpty)
      _items.add(secondaryPhone);
    return _items ?? [];
  }
}
