part of unify;

class CartItem implements UnifyObject {
  CartItem(this.client, this.json);

  @override
  final UnifyClient client;

  @override
  final Map<String, dynamic> json;

  String get id => json["Order_Item_ID"];

  String get orderId => json["Order_ID"];

  String get productId => json["Product_ID"];

  String get name => json["Name"];

  String get sku => json["Sku"];

  int get quantity => json["Quantity"];

  num get price => json["Price_Paid"];

  Map<String, dynamic> get attributes {
    Map<String, dynamic> _result = Map<String, dynamic>();
    try {
      String _data = json["Attributes"];
      List<String> _items = _data.split(",");
      for (var item in _items) {
        List<String> _item = item.split(":");
        _result[_item[0]] = _item[1];
      }
    } catch (e) {
      print("Error: $e => ${json["Attributes"]}");
    }
    return _result;
  }

  String get additionalProperties => json["Additional_Properties"];

  num get weight => json["Weight"];

  num get tax => json["Item_Tax"];

  num get discount => json["Discount_Amount"];

  bool get isQuickClick => json["IsQuickClick"];

  String get authorUserID => json["Created_By"];

  String get modifiedUserId => json["Modified_By"];

  DateTime get dateCreated => DateTime.tryParse(json["Created_On"] as String);

  DateTime get dateModified => DateTime.tryParse(json["Modified_On"] as String);
}
